Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
TiXmlNode Class Referenceabstract

`#include <tinyxml.h>`

Inheritance diagram for TiXmlNode:

## Public Types
enum | NodeType { TINYXML_DOCUMENT, TINYXML_ELEMENT, TINYXML_COMMENT, TINYXML_UNKNOWN, TINYXML_TEXT, TINYXML_DECLARATION, TINYXML_TYPECOUNT }
Public Types inherited from TiXmlBase
enum | { TIXML_NO_ERROR = 0, TIXML_ERROR, TIXML_ERROR_OPENING_FILE, TIXML_ERROR_PARSING_ELEMENT, TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TIXML_ERROR_READING_ELEMENT_VALUE, TIXML_ERROR_READING_ATTRIBUTES, TIXML_ERROR_PARSING_EMPTY, TIXML_ERROR_READING_END_TAG, TIXML_ERROR_PARSING_UNKNOWN, TIXML_ERROR_PARSING_COMMENT, TIXML_ERROR_PARSING_DECLARATION, TIXML_ERROR_DOCUMENT_EMPTY, TIXML_ERROR_EMBEDDED_NULL, TIXML_ERROR_PARSING_CDATA, TIXML_ERROR_DOCUMENT_TOP_ONLY, TIXML_ERROR_STRING_COUNT }

## Public Member Functions
virtual | ~TiXmlNode ()
const char * | Value () const
const TIXML_STRING & | ValueTStr () const
void | SetValue (const char *_value)
void | Clear ()
| Delete all the children of this node. Does not affect 'this'. More...
TiXmlNode * | Parent ()
| One step up the DOM. More...
const TiXmlNode * | Parent () const
const TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children. More...
TiXmlNode * | FirstChild ()
const TiXmlNode * | FirstChild (const char *value) const
TiXmlNode * | FirstChild (const char *_value)
| The first child of this node with the matching 'value'. Will be null if none found. More...
const TiXmlNode * | LastChild () const
TiXmlNode * | LastChild ()
| The last child of this node. Will be null if there are no children. More...
const TiXmlNode * | LastChild (const char *value) const
TiXmlNode * | LastChild (const char *_value)
| The last child of this node matching 'value'. Will be null if there are no children. More...
const TiXmlNode * | IterateChildren (const TiXmlNode *previous) const
TiXmlNode * | IterateChildren (const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const char *value, const TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'. More...
TiXmlNode * | IterateChildren (const char *_value, const TiXmlNode *previous)
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node. More...
const TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node. More...
TiXmlNode * | PreviousSibling ()
const TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node. More...
TiXmlNode * | PreviousSibling (const char *_prev)
const TiXmlNode * | NextSibling () const
| Navigate to a sibling node. More...
TiXmlNode * | NextSibling ()
const TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'. More...
TiXmlNode * | NextSibling (const char *_next)
const TiXmlElement * | NextSiblingElement () const
TiXmlElement * | NextSiblingElement ()
const TiXmlElement * | NextSiblingElement (const char *) const
TiXmlElement * | NextSiblingElement (const char *_next)
const TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements. More...
TiXmlElement * | FirstChildElement ()
const TiXmlElement * | FirstChildElement (const char *_value) const
| Convenience function to get through elements. More...
TiXmlElement * | FirstChildElement (const char *_value)
int | Type () const
const TiXmlDocument * | GetDocument () const
TiXmlDocument * | GetDocument ()
bool | NoChildren () const
| Returns true if this node has no children. More...
virtual const TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlText * | ToText () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlDocument * | ToDocument ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlElement * | ToElement ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlComment * | ToComment ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlUnknown * | ToUnknown ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlText * | ToText ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlDeclaration * | ToDeclaration ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlNode * | Clone () const =0
virtual bool | Accept (TiXmlVisitor *visitor) const =0
Public Member Functions inherited from TiXmlBase
| TiXmlBase ()
virtual | ~TiXmlBase ()
virtual void | Print (FileStream &stream, int depth) const =0
int | Row () const
int | Column () const
| See Row() More...
void | SetUserData (void *user)
| Set a pointer to arbitrary user data. More...
void * | GetUserData ()
| Get a pointer to arbitrary user data. More...
const void * | GetUserData () const
| Get a pointer to arbitrary user data. More...
virtual const char * | Parse (const char *p, TiXmlParsingData *data, TiXmlEncoding encoding)=0

## Protected Member Functions
| TiXmlNode (NodeType _type)
void | CopyTo (TiXmlNode *target) const
TiXmlNode * | Identify (const char *start, TiXmlEncoding encoding)

## Protected Attributes
TiXmlNode * | parent
NodeType | type
TiXmlNode * | firstChild
TiXmlNode * | lastChild
TIXML_STRING | value
TiXmlNode * | prev
TiXmlNode * | next
Protected Attributes inherited from TiXmlBase
TiXmlCursor | location
void * | userData
| Field containing a generic user pointer. More...

## Friends
class | TiXmlDocument
class | TiXmlElement

## Additional Inherited Members
Static Public Member Functions inherited from TiXmlBase
static void | SetCondenseWhiteSpace (bool condense)
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting. More...
static void | EncodeString (const TIXML_STRING &str, TIXML_STRING *out)
Static Public Attributes inherited from TiXmlBase
static const int | utf8ByteTable [256]
Static Protected Member Functions inherited from TiXmlBase
static const char * | SkipWhiteSpace (const char *, TiXmlEncoding encoding)
static bool | IsWhiteSpace (char c)
static bool | IsWhiteSpace (int c)
static const char * | ReadName (const char *p, TIXML_STRING *name, TiXmlEncoding encoding)
static const char * | ReadText (const char *in, TIXML_STRING *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static const char * | GetEntity (const char *in, char *value, int *length, TiXmlEncoding encoding)
static const char * | GetChar (const char *p, char *_value, int *length, TiXmlEncoding encoding)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static int | IsAlpha (unsigned char anyByte, TiXmlEncoding encoding)
static int | IsAlphaNum (unsigned char anyByte, TiXmlEncoding encoding)
static int | ToLower (int v, TiXmlEncoding encoding)
static void | ConvertUTF32ToUTF8 (unsigned long input, char *output, int *length)
Static Protected Attributes inherited from TiXmlBase
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Detailed Description

The parent class for everything in the Document Object Model. (Except for attributes). Nodes have siblings, a parent, and children. A node can be in a document, or stand on its own. The type of a TiXmlNode can be queried, and it can be cast to its more defined type.

## Member Enumeration Documentation

enum NodeType

The types of XML nodes supported by TinyXml. (All the unsupported types are picked up by UNKNOWN.)

Enumerator
TINYXML_DOCUMENT |
TINYXML_ELEMENT |
TINYXML_COMMENT |
TINYXML_UNKNOWN |
TINYXML_TEXT |
TINYXML_DECLARATION |
TINYXML_TYPECOUNT |

## Constructor & Destructor Documentation

~TiXmlNode | ( |  | ) |
| virtual

TiXmlNode | ( | NodeType | _type | ) |
| protected

## Member Function Documentation

virtual bool Accept | ( | TiXmlVisitor * | visitor | ) | const
| pure virtual

Accept a hierchical visit the nodes in the TinyXML DOM. Every node in the XML tree will be conditionally visited and the host will be called back via the TiXmlVisitor interface.

This is essentially a SAX interface for TinyXML. (Note however it doesn't re-parse the XML for the callbacks, so the performance of TinyXML is unchanged by using this interface versus any other.)

The interface has been based on ideas from:

- http://www.saxproject.org/
- http://c2.com/cgi/wiki?HierarchicalVisitorPattern

Which are both good references for "visiting".

An example of using Accept():

    TiXmlPrinter printer;
    tinyxmlDoc.Accept( &printer );
    const char* xmlcstr = printer.CStr();

Implemented in TiXmlDocument, TiXmlUnknown, TiXmlDeclaration, TiXmlText, TiXmlComment, and TiXmlElement.

void Clear | ( |  | ) |

Delete all the children of this node. Does not affect 'this'.

virtual TiXmlNode* Clone | ( |  | ) | const
| pure virtual

Create an exact duplicate of this node and return it. The memory must be deleted by the caller.

Implemented in TiXmlDocument, TiXmlUnknown, TiXmlDeclaration, TiXmlText, TiXmlComment, and TiXmlElement.

void CopyTo | ( | TiXmlNode * | target | ) | const
| protected

const TiXmlNode* FirstChild | ( |  | ) | const
| inline

The first child of this node. Will be null if there are no children.

TiXmlNode* FirstChild | ( |  | ) |
| inline

const TiXmlNode * FirstChild | ( | const char * | value | ) | const

The first child of this node with the matching 'value'. Will be null if none found.

TiXmlNode* FirstChild | ( | const char * | _value | ) |
| inline

The first child of this node with the matching 'value'. Will be null if none found.

const TiXmlElement * FirstChildElement | ( |  | ) | const

Convenience function to get through elements.

TiXmlElement* FirstChildElement | ( |  | ) |
| inline

const TiXmlElement * FirstChildElement | ( | const char * | _value | ) | const

Convenience function to get through elements.

TiXmlElement* FirstChildElement | ( | const char * | _value | ) |
| inline

const TiXmlDocument * GetDocument | ( |  | ) | const

Return a pointer to the Document this node lives in. Returns null if not in a document.

TiXmlDocument* GetDocument | ( |  | ) |
| inline

TiXmlNode * Identify | ( | const char * | start,
|  | TiXmlEncoding | encoding
| ) |  |
| protected

TiXmlNode * InsertAfterChild | ( | TiXmlNode * | afterThis,
|  | const TiXmlNode & | addThis
| ) |  |

Add a new node related to this. Adds a child after the specified child. Returns a pointer to the new object or NULL if an error occured.

TiXmlNode * InsertBeforeChild | ( | TiXmlNode * | beforeThis,
|  | const TiXmlNode & | addThis
| ) |  |

Add a new node related to this. Adds a child before the specified child. Returns a pointer to the new object or NULL if an error occured.

TiXmlNode * InsertEndChild | ( | const TiXmlNode & | addThis | ) |

Add a new node related to this. Adds a child past the LastChild. Returns a pointer to the new object or NULL if an error occured.

const TiXmlNode * IterateChildren | ( | const TiXmlNode * | previous | ) | const

An alternate way to walk the children of a node. One way to iterate over nodes is:

        for( child = parent->FirstChild(); child; child = child->NextSibling() )

IterateChildren does the same thing with the syntax:

        child = 0;
        while( child = parent->IterateChildren( child ) )

IterateChildren takes the previous child as input and finds the next one. If the previous child is null, it returns the first. IterateChildren will return null when done.

TiXmlNode* IterateChildren | ( | const TiXmlNode * | previous | ) |
| inline

const TiXmlNode * IterateChildren | ( | const char * | value,
|  | const TiXmlNode * | previous
| ) |  | const

This flavor of IterateChildren searches for children with a particular 'value'.

TiXmlNode* IterateChildren | ( | const char * | _value,
|  | const TiXmlNode * | previous
| ) |  |
| inline

const TiXmlNode* LastChild | ( |  | ) | const
| inline

TiXmlNode* LastChild | ( |  | ) |
| inline

The last child of this node. Will be null if there are no children.

const TiXmlNode * LastChild | ( | const char * | value | ) | const

TiXmlNode* LastChild | ( | const char * | _value | ) |
| inline

The last child of this node matching 'value'. Will be null if there are no children.

TiXmlNode * LinkEndChild | ( | TiXmlNode * | addThis | ) |

Add a new node related to this. Adds a child past the LastChild.

NOTE: the node to be added is passed by pointer, and will be henceforth owned (and deleted) by tinyXml. This method is efficient and avoids an extra copy, but should be used with care as it uses a different memory model than the other insert functions.

See also
  InsertEndChild

const TiXmlNode* NextSibling | ( |  | ) | const
| inline

Navigate to a sibling node.

TiXmlNode* NextSibling | ( |  | ) |
| inline

const TiXmlNode * NextSibling | ( | const char * | _value | ) | const

Navigate to a sibling node with the given 'value'.

TiXmlNode* NextSibling | ( | const char * | _next | ) |
| inline

const TiXmlElement * NextSiblingElement | ( |  | ) | const

Convenience function to get through elements. Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

TiXmlElement* NextSiblingElement | ( |  | ) |
| inline

const TiXmlElement * NextSiblingElement | ( | const char * | _value | ) | const

Convenience function to get through elements. Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

TiXmlElement* NextSiblingElement | ( | const char * | _next | ) |
| inline

bool NoChildren | ( |  | ) | const
| inline

Returns true if this node has no children.

TiXmlNode* Parent | ( |  | ) |
| inline

One step up the DOM.

const TiXmlNode* Parent | ( |  | ) | const
| inline

const TiXmlNode* PreviousSibling | ( |  | ) | const
| inline

Navigate to a sibling node.

TiXmlNode* PreviousSibling | ( |  | ) |
| inline

const TiXmlNode * PreviousSibling | ( | const char * | _value | ) | const

Navigate to a sibling node.

TiXmlNode* PreviousSibling | ( | const char * | _prev | ) |
| inline

bool RemoveChild | ( | TiXmlNode * | removeThis | ) |

Delete a child of this node.

TiXmlNode * ReplaceChild | ( | TiXmlNode * | replaceThis,
|  | const TiXmlNode & | withThis
| ) |  |

Replace a child of this node. Returns a pointer to the new object or NULL if an error occured.

void SetValue | ( | const char * | _value | ) |
| inline

Changes the value of the node. Defined as:

    Document:   filename of the xml file
    Element:    name of the element
    Comment:    the comment text
    Unknown:    the tag contents
    Text:       the text string

virtual const TiXmlComment* ToComment | ( |  | ) | const
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlComment.

virtual TiXmlComment* ToComment | ( |  | ) |
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlComment.

virtual const TiXmlDeclaration* ToDeclaration | ( |  | ) | const
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlDeclaration.

virtual TiXmlDeclaration* ToDeclaration | ( |  | ) |
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlDeclaration.

virtual const TiXmlDocument* ToDocument | ( |  | ) | const
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlDocument.

virtual TiXmlDocument* ToDocument | ( |  | ) |
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlDocument.

virtual const TiXmlElement* ToElement | ( |  | ) | const
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlElement.

virtual TiXmlElement* ToElement | ( |  | ) |
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlElement.

virtual const TiXmlText* ToText | ( |  | ) | const
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlText.

virtual TiXmlText* ToText | ( |  | ) |
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlText.

virtual const TiXmlUnknown* ToUnknown | ( |  | ) | const
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlUnknown.

virtual TiXmlUnknown* ToUnknown | ( |  | ) |
| inline virtual

Cast to a more defined type. Will return null if not of the requested type.

Reimplemented in TiXmlUnknown.

int Type | ( |  | ) | const
| inline

Query the type (as an enumerated value, above) of this node. The possible types are: TINYXML_DOCUMENT, TINYXML_ELEMENT, TINYXML_COMMENT, TINYXML_UNKNOWN, TINYXML_TEXT, and TINYXML_DECLARATION.

const char* Value | ( |  | ) | const
| inline

The meaning of 'value' changes for the specific type of TiXmlNode.

    Document:   filename of the xml file
    Element:    name of the element
    Comment:    the comment text
    Unknown:    the tag contents
    Text:       the text string

The subclasses will wrap this function.

const TIXML_STRING& ValueTStr | ( |  | ) | const
| inline

## Friends And Related Function Documentation

friend class TiXmlDocument
| friend

friend class TiXmlElement
| friend

## Member Data Documentation

TiXmlNode* firstChild
| protected

TiXmlNode* lastChild
| protected

TiXmlNode* next
| protected

TiXmlNode* parent
| protected

TiXmlNode* prev
| protected

NodeType type
| protected

TIXML_STRING value
| protected

The documentation for this class was generated from the following files:

- persistence/tinyXML/tinyxml.h
- persistence/tinyXML/tinyxml.cpp
- persistence/tinyXML/tinyxmlparser.cpp